# Author renyupeng
# coding=utf-8
# @Time    : 2021/12/20 11:18 上午
# @Site    : 
# @File    : send_material_report_weekly.py.py
# @Software: PyCharm
# @contact: renyupeng@c-top.com.cn
# @Tel 1501435553
import datetime
from urllib import parse
import pandas as pd
import smtplib
from email.mime.text import MIMEText
from email.mime.multipart import MIMEMultipart
from sqlalchemy import create_engine


class send_material_report_weekly:
    def __init__(self):
        self.OuterStr = "mysql+pymysql://%s:%s@%s:%d/%s" % (
            "data", parse.quote_plus("hcst@2021"), "139.186.27.96", 3390, "jeecg-boot")
        self.OuterConn = create_engine(self.OuterStr,
                                       pool_size=10,
                                       max_overflow=5,
                                       pool_timeout=10,
                                       pool_recycle=3600)
        self.stat_date = (datetime.date.today() + datetime.timedelta(-1)).strftime("%Y-%m-%d")

    def handler(self):
        sql = """SELECT
        ifnull(t2.company_name,'0') AS '公司',
        ifnull(t3.project_name,'-') AS '项目',
        ifnull(t2.video_code,'-') AS '素材标识',
        ifnull(t2.state_date,'-') AS '上线时间',
        ifnull(t2.channel_name,'-') AS '渠道',
        round(sum(t1.charge),3) AS '消耗',
        ifnull(t2.clip_name,'-') AS '剪辑',
        ifnull(t2.shot_name,'-') AS '拍摄',
        ifnull(t2.plan_name,'-') AS '编导',
        ifnull(t2.design_team_leader_name,'-') AS '负责人',
        ifnull(t2.video_name,'-') AS '素材名称',
        ifnull(t2.url,'-') AS '链接'
FROM
`jeecg-boot`.ctop_etl_kuaishou_account_material_report_daily t1
LEFT JOIN `jeecg-boot`.ctop_etl_kuaishou_video_info t2 ON t1.signature = t2.video_code
LEFT JOIN `jeecg-boot`.ctop_project t3
on t1.project_id=t3.id
where t1.stat_date between date_sub('{stat_date}', INTERVAL 6 DAY)  and '{stat_date}' 
GROUP BY
t1.signature""".format(stat_date=self.stat_date)
        print(sql)
        path = """/data/excel/material_week_{stat_date}.xls""".format(stat_date=self.stat_date)
        print(path)
        pd.read_sql(sql, self.OuterConn).to_excel(path, index=False, engine='openpyxl')
        my_sender = 'notice@c-top.com.cn'  # 发件人邮箱账号
        my_pass = 'Hcst@2021'  # 发件人邮箱授权码 / 腾讯企业邮箱请使用登陆密码
        recipients = ['wanglei@c-top.com.cn','niuxiaoyu@c-top.com.cn','dukexuan@c-top.com.cn','zhaohailiang@c-top.com.cn']  # 收件人邮箱账号
        # content = "Please check the attachment. "
        msg = MIMEMultipart()
        # [发件人的邮箱昵称、发件人邮箱账号], 昵称随便
        msg['From'] = my_sender
        # [收件人邮箱昵称、收件人邮箱账号], 昵称随便
        msg['To'] = ",".join(recipients)
        # 邮件的主题，也就是邮件的标题
        msg['Subject'] = "快手-全量素材周报"

        att1 = MIMEText(
            open(path, 'rb').read(), 'base64', 'utf-8')
        att1["Content-Type"] = 'application/octet-stream'
        att1["Content-Disposition"] = 'attachment; filename="material_report_weekly.xls"'
        msg.attach(att1)
        server = smtplib.SMTP_SSL("smtp.exmail.qq.com", port=465)
        server.login(my_sender, my_pass)
        try:
            server.sendmail(my_sender, recipients, msg.as_string())
            print("发送成功")
        except Exception as e:
            print("发送失败",e)


if __name__ == '__main__':
    send_material_report_weekly().handler()
